"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
import dateutil.parser
from airbyte_api import utils
from dataclasses_json import Undefined, dataclass_json
from datetime import datetime
from enum import Enum
from typing import Final, Optional


class DataRegion(str, Enum):
    r"""Amplitude data region server"""
    STANDARD_SERVER = 'Standard Server'
    EU_RESIDENCY_SERVER = 'EU Residency Server'


class Amplitude(str, Enum):
    AMPLITUDE = 'amplitude'


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class SourceAmplitude:
    api_key: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('api_key') }})
    r"""Amplitude API Key. See the <a href=\\"https://docs.airbyte.com/integrations/sources/amplitude#setup-guide\\">setup guide</a> for more information on how to obtain this key."""
    secret_key: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('secret_key') }})
    r"""Amplitude Secret Key. See the <a href=\\"https://docs.airbyte.com/integrations/sources/amplitude#setup-guide\\">setup guide</a> for more information on how to obtain this key."""
    start_date: datetime = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('start_date'), 'encoder': utils.datetimeisoformat(False), 'decoder': dateutil.parser.isoparse }})
    r"""UTC date and time in the format 2021-01-25T00:00:00Z. Any data before this date will not be replicated."""
    data_region: Optional[DataRegion] = dataclasses.field(default=DataRegion.STANDARD_SERVER, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('data_region'), 'exclude': lambda f: f is None }})
    r"""Amplitude data region server"""
    request_time_range: Optional[int] = dataclasses.field(default=24, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('request_time_range'), 'exclude': lambda f: f is None }})
    r"""According to <a href=\\"https://www.docs.developers.amplitude.com/analytics/apis/export-api/#considerations\\">Considerations</a> too big time range in request can cause a timeout error. In this case, set shorter time interval in hours."""
    SOURCE_TYPE: Final[Amplitude] = dataclasses.field(default=Amplitude.AMPLITUDE, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('sourceType') }})
    

