"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
from airbyte_api import utils
from dataclasses_json import Undefined, dataclass_json
from datetime import date
from enum import Enum
from typing import Final, List, Optional


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class GoogleCredentials:
    client_id: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('client_id') }})
    r"""The Client ID of your Google Ads developer application. For detailed instructions on finding this value, refer to our <a href=\\"https://docs.airbyte.com/integrations/sources/google-ads#setup-guide\\">documentation</a>."""
    client_secret: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('client_secret') }})
    r"""The Client Secret of your Google Ads developer application. For detailed instructions on finding this value, refer to our <a href=\\"https://docs.airbyte.com/integrations/sources/google-ads#setup-guide\\">documentation</a>."""
    developer_token: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('developer_token') }})
    r"""The Developer Token granted by Google to use their APIs. For detailed instructions on finding this value, refer to our <a href=\\"https://docs.airbyte.com/integrations/sources/google-ads#setup-guide\\">documentation</a>."""
    refresh_token: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('refresh_token') }})
    r"""The token used to obtain a new Access Token. For detailed instructions on finding this value, refer to our <a href=\\"https://docs.airbyte.com/integrations/sources/google-ads#setup-guide\\">documentation</a>."""
    access_token: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('access_token'), 'exclude': lambda f: f is None }})
    r"""The Access Token for making authenticated requests. For detailed instructions on finding this value, refer to our <a href=\\"https://docs.airbyte.com/integrations/sources/google-ads#setup-guide\\">documentation</a>."""
    



@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class CustomQueriesArray:
    query: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('query') }})
    r"""A custom defined GAQL query for building the report. Avoid including the segments.date field; wherever possible, Airbyte will automatically include it for incremental syncs. For more information, refer to <a href=\\"https://developers.google.com/google-ads/api/fields/v11/overview_query_builder\\">Google's documentation</a>."""
    table_name: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('table_name') }})
    r"""The table name in your destination database for the chosen query."""
    



class CustomerStatus(str, Enum):
    r"""An enumeration."""
    UNKNOWN = 'UNKNOWN'
    ENABLED = 'ENABLED'
    CANCELED = 'CANCELED'
    SUSPENDED = 'SUSPENDED'
    CLOSED = 'CLOSED'


class SourceGoogleAdsGoogleAds(str, Enum):
    GOOGLE_ADS = 'google-ads'


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class SourceGoogleAds:
    credentials: GoogleCredentials = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('credentials') }})
    conversion_window_days: Optional[int] = dataclasses.field(default=14, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('conversion_window_days'), 'exclude': lambda f: f is None }})
    r"""A conversion window is the number of days after an ad interaction (such as an ad click or video view) during which a conversion, such as a purchase, is recorded in Google Ads. For more information, see <a href=\\"https://support.google.com/google-ads/answer/3123169?hl=en\\">Google's documentation</a>."""
    custom_queries_array: Optional[List[CustomQueriesArray]] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('custom_queries_array'), 'exclude': lambda f: f is None }})
    customer_id: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('customer_id'), 'exclude': lambda f: f is None }})
    r"""Comma-separated list of (client) customer IDs. Each customer ID must be specified as a 10-digit number without dashes. For detailed instructions on finding this value, refer to our <a href=\\"https://docs.airbyte.com/integrations/sources/google-ads#setup-guide\\">documentation</a>."""
    customer_status_filter: Optional[List[CustomerStatus]] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('customer_status_filter'), 'exclude': lambda f: f is None }})
    r"""A list of customer statuses to filter on. For detailed info about what each status mean refer to Google Ads <a href=\\"https://developers.google.com/google-ads/api/reference/rpc/v15/CustomerStatusEnum.CustomerStatus\\">documentation</a>."""
    end_date: Optional[date] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('end_date'), 'encoder': utils.dateisoformat(True), 'decoder': utils.datefromisoformat, 'exclude': lambda f: f is None }})
    r"""UTC date in the format YYYY-MM-DD. Any data after this date will not be replicated. (Default value of today is used if not set)"""
    SOURCE_TYPE: Final[SourceGoogleAdsGoogleAds] = dataclasses.field(default=SourceGoogleAdsGoogleAds.GOOGLE_ADS, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('sourceType') }})
    start_date: Optional[date] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('start_date'), 'encoder': utils.dateisoformat(True), 'decoder': utils.datefromisoformat, 'exclude': lambda f: f is None }})
    r"""UTC date in the format YYYY-MM-DD. Any data before this date will not be replicated. (Default value of two years ago is used if not set)"""
    

