"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
import dateutil.parser
from airbyte_api import utils
from dataclasses_json import Undefined, dataclass_json
from datetime import datetime
from enum import Enum
from typing import Final, Optional


class DataCenterLocation(str, Enum):
    r"""Please choose the region of your Data Center location. More info by this <a href=\\"https://www.zoho.com/crm/developer/docs/api/v2/multi-dc.html\\">Link</a>"""
    US = 'US'
    AU = 'AU'
    EU = 'EU'
    IN = 'IN'
    CN = 'CN'
    JP = 'JP'


class ZohoCRMEdition(str, Enum):
    r"""Choose your Edition of Zoho CRM to determine API Concurrency Limits"""
    FREE = 'Free'
    STANDARD = 'Standard'
    PROFESSIONAL = 'Professional'
    ENTERPRISE = 'Enterprise'
    ULTIMATE = 'Ultimate'


class SourceZohoCrmEnvironment(str, Enum):
    r"""Please choose the environment"""
    PRODUCTION = 'Production'
    DEVELOPER = 'Developer'
    SANDBOX = 'Sandbox'


class ZohoCrm(str, Enum):
    ZOHO_CRM = 'zoho-crm'


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class SourceZohoCrm:
    UNSET='__SPEAKEASY_UNSET__'
    client_id: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('client_id') }})
    r"""OAuth2.0 Client ID"""
    client_secret: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('client_secret') }})
    r"""OAuth2.0 Client Secret"""
    dc_region: DataCenterLocation = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('dc_region') }})
    r"""Please choose the region of your Data Center location. More info by this <a href=\\"https://www.zoho.com/crm/developer/docs/api/v2/multi-dc.html\\">Link</a>"""
    environment: SourceZohoCrmEnvironment = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('environment') }})
    r"""Please choose the environment"""
    refresh_token: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('refresh_token') }})
    r"""OAuth2.0 Refresh Token"""
    edition: Optional[ZohoCRMEdition] = dataclasses.field(default=ZohoCRMEdition.FREE, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('edition'), 'exclude': lambda f: f is None }})
    r"""Choose your Edition of Zoho CRM to determine API Concurrency Limits"""
    SOURCE_TYPE: Final[ZohoCrm] = dataclasses.field(default=ZohoCrm.ZOHO_CRM, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('sourceType') }})
    start_datetime: Optional[datetime] = dataclasses.field(default=UNSET, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('start_datetime'), 'encoder': utils.datetimeisoformat(True), 'decoder': utils.decodeunset(dateutil.parser.isoparse), 'exclude': lambda f: f is SourceZohoCrm.UNSET }})
    r"""ISO 8601, for instance: `YYYY-MM-DD`, `YYYY-MM-DD HH:MM:SS+HH:MM`"""
    

